# only DTLZ1-4 problems are shown for example

import numpy as np
from math import *


def DTLZ1(input_arr, n_obj):
    n_var = len(input_arr)
    k = n_var - n_obj + 1
    f = [0.0] * n_obj
    g = 0.0
    for i in range(n_var - k, n_var):
        g = g + ((input_arr[i] - 0.5) ** 2) - cos(20 * pi * (input_arr[i] - 0.5))
    g = 100 * (k + g)
    for i in range(1, n_obj + 1):
        s = 0.5 * (1 + g)
        j = n_obj - i
        while j >= 1:
            j = j - 1
            s = s * input_arr[j]
        if i > 1:
            s = s * (1 - input_arr[n_obj - i])
        f[i - 1] = s
    return np.asarray(f)


def DTLZ2(input_arr, n_obj):
    n_var = len(input_arr)
    k = n_var - n_obj + 1
    f = [0.0] * n_obj
    g = 0.0
    for i in range(n_var - k, n_var):
        g = g + ((input_arr[i] - 0.5) ** 2)
    for i in range(1, n_obj + 1):
        s = (1.0 + g)
        j = n_obj - i
        while j >= 1:
            j = j - 1
            s = s * cos(pi * input_arr[j] * 0.5)
        if i > 1:
            s = s * sin(input_arr[n_obj - i] * pi / 2)
        f[i - 1] = s
    return np.asarray(f)


def DTLZ3(input_arr, n_obj):
    n_var = len(input_arr)
    k = n_var - n_obj + 1

    g = 0
    for i in range(n_obj - 1, n_var):
        g += (((input_arr[i] - 0.5) ** 2) - cos(20.0 * pi * (input_arr[i] - 0.5)))
    g = (k + g) * 100
    out = np.zeros(n_obj)

    for m in range(0, n_obj):
        product = (1 + g)
        i = 0
        while ((i + m) <= n_obj - 2):
            product *= cos(input_arr[i] * pi / 2)
            i += 1
        if m > 0:
            product *= sin(input_arr[i] * pi / 2)
        out[m] = product
    return np.asarray(out)


def DTLZ4(input_arr, n_obj, a=100):
    n_var = len(input_arr)
    k = n_var - n_obj + 1

    g = 0
    for i in range(n_obj - 1, n_var):
        g += ((input_arr[i] - 0.5) ** 2)
    out = np.zeros(n_obj)
    for m in range(0, n_obj):
        product = (1 + g)
        i = 0
        while ((i + m) <= n_obj - 2):
            product *= cos((input_arr[i] ** a) * pi / 2)
            i += 1
        if m > 0:
            product *= sin((input_arr[i] ** a) * pi / 2)
        out[m] = product
    return np.asarray(out)


def evaluate(func, decision, n_obj):
    if func == 'DTLZ1':
        return DTLZ1(decision, n_obj)
    elif func == 'DTLZ2':
        return DTLZ2(decision, n_obj)
    elif func == 'DTLZ3':
        return DTLZ3(decision, n_obj)
    elif func == 'DTLZ4':
        return DTLZ4(decision, n_obj)
